<?php
class SplashScreen extends CFormModel {
	
    protected $config = "/etc/default/splash";
    protected $defpath = "/usr/share/resources/default/splash";
    
    var $BOOTIMG = null;
    var $SHUTDOWNIMG = null;
    var $FIRMUPDIMG = null;
    
    var $BOOTIMG_link;
    var $SHUTDOWNIMG_link;
    var $FIRMUPDIMG_link;
    
    var $fileslists=array(  
                            "BOOTIMG"=>"/etc/spinetix/splash/splash", 
                            "SHUTDOWNIMG"=>"/etc/spinetix/splash/shutdown", 
                            "FIRMUPDIMG"=>"/etc/spinetix/splash/fimrware-upd"
                        );
    
    public function rules() {
		$res = array(
            array( "BOOTIMG, SHUTDOWNIMG, FIRMUPDIMG", 'file', 'types'=>'jpg, png', 'maxSize'=>1024*1024 ,'allowEmpty'=>true, 'on'=>'setsplash' ),
    	);
        return $res;
	}
    public function attributeLabels()
	{
		return array(
            'BOOTIMG'=>'Boot splash screen',
            'SHUTDOWNIMG'=>'Shutdown splash screen',
            'FIRMUPDIMG'=>'Firmware upgrade splash screen',
		);
	}
    function reset() {
        if ( file_exists( $this->config.".spxsave" ) )
            file_put_contents( $this->config, file_get_contents( $this->config.".spxsave"));
        else 
             $this->addError('file',"Cannot find the backup logo config file. Please re-install the firmware to solve the problem");
    }
    function load() {
        if ( !file_exists( $this->config ) )
            reset();
        
        $logoconf=file_get_contents($this->config);
        
        foreach ($this->fileslists as $fn=>$dstfn ){
            if ( preg_match("/^\s*$fn=(.*)/m",$logoconf,$match)==1 ){
                $tmp = $match[1];
                
                if ( dirname($tmp)==$this->defpath ) $source="default";
                else $source="user";
                $file = basename($tmp);
                $n = $fn."_link";
                $this->$n="showlogo.php?name=$file&source=$source";
            }
        }
        return $logoconf;
    }

    function save() {
        $mustSave = false;
        
        $logoconf = $this->load();
        
        foreach ($this->fileslists as $fn=>$dstfn ){
            if ( $this->$fn==null ) continue;
            
            $dstName = $dstfn.$this->$fn->extensionName;
            
            $this->$fn->saveAs( $dstName );
            $logoconf = preg_replace("/$fn=.*/","$fn=$dstName",$logoconf);
            $mustSave = true;
            
            $file=basename($dstName);
            $n = $fn."_link";
            $this->$n="showlogo.php?name=$file&source=user";
            
        }
        
        if ($mustSave){
            file_put_contents( $this->config, $logoconf );
        }
    }

}