<?php


$logs_str = $firmware->getLog( );
$nbUpdates = $firmware->getNbUpdates();

if ( !$firmware->isUpdateRunning() )
    echo "<!--- Stop refresh --->";
else {
     // show progress bar
    echo CHtml::tag("br");
    echo CHtml::image("images/loadingAnimation.gif", "Loading..." );
    echo CHtml::tag("br");
    echo CHtml::tag("br");
}
    
echo CHtml::tag("h3", array(), CHtml::link("Show update log", "#", array('id'=>'hide_log')) );
echo CHtml::openTag("div", array("class"=>"logs") );
foreach( $logs_str as $line ) {
    echo CHtml::encode($line) . Chtml::tag("br");
}
echo CHtml::closeTag("div" );




if ( $firmware->mode=='check' ) {
    if ( $nbUpdates!==false ) {
        // we have some info about the firmware
        if ($nbUpdates==0){
            echo CHtml::tag("h3", array(), "No updates available");
            echo CHtml::openTag("div", array( 'class'=>'action') );
            echo CHtml::submitButton("OK", array('name'=>'cancel') ) ." ";
            echo CHtml::closeTag("div" );
        } else {
            echo CHtml::tag("h3", array(), CHtml::encode($nbUpdates) . " updates available");
            if ( $firmware->updater->update_info['type'] == 'FIRMWARE') {
                echo "Updating now would install firmware version ". CHtml::encode( $firmware->updater->update_info['ver'] ) .
                     " (build " . CHtml::encode( $firmware->updater->update_info['rel']) .  ")\n";
            } elseif ( $firmware->updater->update_info['type'] == 'UPDATER') {
                echo "Updating now would install updater version " .CHtml::encode( $firmware->updater->update_info['ver'] ) .
                     " (build " . CHtml::encode( $firmware->updater->update_info['rel']) .  "), which is required to perform other updates.\n";
            } else {
                echo "Update would only install some minor components.\n";
            }
            
            echo CHtml::openTag("div", array( 'class'=>'action') );
            echo CHtml::activeHiddenField($firmware, "updatesource");
            echo CHtml::activeHiddenField($firmware, "mode", array('value'=>"update") );
            
            if ( $firmware->updater->updater_status=="OK")
                echo CHtml::submitButton("Update Now", array('name'=>'update') ) ." ";
            else 
                echo CHtml::tag("h3", array(), "Check for update failed") . "<br/>";    
            echo CHtml::submitButton("Cancel", array('name'=>'cancel') ) ." ";
            echo CHtml::closeTag("div" );
        }
    } elseif ( !$firmware->isUpdateRunning() ) {
        echo CHtml::tag("h3", array(), "Update check failed");    
        echo "Please check the logs for more details.";
        echo CHtml::openTag("div", array( 'class'=>'action space') );
        echo CHtml::submitButton("Cancel", array('name'=>'cancel') ) ." ";
        echo CHtml::closeTag("div" );
    }
} else {
    // update
    if ( !$firmware->isUpdateRunning() ) {
        if ( $firmware->updater->updater_status=="OK") {
            if ( $firmware->updater->update_info['type'] == 'FIRMWARE') {
                echo "Installed firmware version ". CHtml::encode( $firmware->updater->update_info['ver'] ) .
                     " (build " . CHtml::encode( $firmware->updater->update_info['rel']) .  ")\n";
            } elseif ( $firmware->updater->update_info['type'] == 'UPDATER') {
                echo "Installed updater version " .CHtml::encode( $firmware->updater->update_info['ver'] ) .
                     " (build " . CHtml::encode( $firmware->updater->update_info['rel']) .  "), which is required to perform other updates.\n";
            } else {
                echo "Installed some minor components.\n";
            }
        
            if ( $firmware->updater->updater_fallback ) {
                echo "<br/>\n";
                echo "Other updates are still awaiting installation, please check ".
                       "for updates again and perform an update if any are proposed ".
                       "in order to have an up to date firmware.\n";
            
                echo CHtml::openTag("div", array( 'class'=>'action') );
                echo CHtml::activeHiddenField($firmware, "updatesource");
                echo CHtml::activeHiddenField($firmware, "mode", array('value'=>"check") );
                echo CHtml::submitButton("Check for Update", array('name'=>'update') ) ." ";
                echo CHtml::submitButton("Cancel", array('name'=>'cancel') ) ." ";
                echo CHtml::closeTag("div" );
            } else {
                echo CHtml::openTag("div", array( 'class'=>'action') );
                echo CHtml::submitButton("OK", array('name'=>'cancel') ) ." ";
                echo CHtml::closeTag("div" );
            }
        } else {
            echo CHtml::tag("h3", array(), "Update failed");    
            echo CHtml::openTag("div", array( 'class'=>'action space') );
            echo CHtml::submitButton("Cancel", array('name'=>'cancel') ) ." ";
            echo CHtml::closeTag("div" );
        }
    } 
}
